﻿Option Strict On
Option Explicit On
Imports System.ComponentModel
Imports System.Net

Public Class DownloadController

    Public Shared UnpackFiles As Boolean = False
    Public Shared wc As New Net.WebClient
    Public Shared pathOfFiles As String = ""

    Public Shared Function DownloadFrom(ByVal url As String, ByVal path As String) As Boolean
        pathOfFiles = path
        AddHandler wc.DownloadProgressChanged, AddressOf UpdateProgress
        AddHandler wc.DownloadFileCompleted, AddressOf DoUnpack
        Dim C As New Uri(url)
        Try
            wc.DownloadFileAsync(C, path)
            Return True
        Catch ex As Exception
            Return False
        End Try
    End Function

    Private Shared Sub DoUnpack(sender As Object, e As AsyncCompletedEventArgs)
        If UnpackFiles Then
            ActionController.UnZip(Form1.destination.Text.Replace(Form1.destination.Text.Split(CType("\", Char())).Last, Nothing), pathOfFiles)
        End If
    End Sub

    Private Shared Sub UpdateProgress(sender As Object, e As DownloadProgressChangedEventArgs)
        Form1.percentage.Text = e.ProgressPercentage.ToString + "%"
        Form1.progress.Value = e.ProgressPercentage
    End Sub

    Public Shared Function CancelDownloadFile() As Boolean
        Try
            wc.CancelAsync()
            Return True
        Catch ex As Exception
            Return False
        End Try
    End Function

End Class
